﻿using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using System.Collections.Specialized;
using System.Collections;
using System.Windows.Threading;
using System.Windows;
using System.Collections.ObjectModel;

namespace SampleLOBApp.Model
{
    public class TickerBuffer : DependencyObject, INotifyCollectionChanged, IList
    {
        public static bool IsCollectionChangedActivated = true;
        
        public int WindowSize
        {
            get { return (int)GetValue(WindowSizeProperty); }
            set { SetValue(WindowSizeProperty, value); }
        }

        public static readonly DependencyProperty WindowSizeProperty =
            DependencyProperty.Register("WindowSize", typeof(int), typeof(TickerBuffer), new UIPropertyMetadata(0));

        private ObservableCollection<Order> _dataSource = new ObservableCollection<Order>();
        private int _windowSize;
        private DispatcherTimer updateTimer = new DispatcherTimer() { Interval = TimeSpan.FromSeconds(1) };

        public TickerBuffer() : this(100)
        {

        }

        public TickerBuffer(int windowSize)
        {
            _windowSize = windowSize;
            this.FillWindow();
            updateTimer.Tick += new EventHandler(timer_Tick);
            updateTimer.Start();
        }

        public TimeSpan FeedUpdateInterval
        {
            get
            {
                return updateTimer.Interval;
            }
            set
            {
                updateTimer.Interval = value;
            }
        }

        Random rand = new Random();
        Order currentlyUpdatedOrder = null;

        private decimal GetRoundedRandom()
        {
            return Math.Round((decimal)rand.NextDouble() * 10 - 5, 2);
        }

        void timer_Tick(object sender, EventArgs e)
        {
            _dataSource.Add(Order.Initialize());

            for (int i = 0; i < _dataSource.Count; ++i)
            {
                currentlyUpdatedOrder = _dataSource[i];
                currentlyUpdatedOrder.Size += 100;
                currentlyUpdatedOrder.Filled += 1;
                currentlyUpdatedOrder.Remain -= 1;
                if (currentlyUpdatedOrder.Remain <= 0)
                {
                    currentlyUpdatedOrder.Remain = 0;
                    currentlyUpdatedOrder.Status = "Filled";
                }
                else
                {
                    currentlyUpdatedOrder.Status = "Partial";
                }

                currentlyUpdatedOrder.ColumnA += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnB += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnC += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnD += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnE += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnF += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnG += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnH += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnI += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnJ += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnK += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnL += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnM += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnN += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnO += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnP += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnQ += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnR += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnS += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnT += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnU += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnV += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnW += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnX += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnY += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnZ += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAA += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAB += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAC += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAD += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAE += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAF += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAG += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAH += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAI += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAJ += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAK += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAL += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAM += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAN += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAO += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAP += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAQ += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAR += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAS += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAT += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAU += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAV += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAW += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAX += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAY += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnAZ += GetRoundedRandom();

                currentlyUpdatedOrder.ColumnBA += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBB += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBC += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBD += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBE += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBF += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBG += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBH += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBI += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBJ += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBK += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBL += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBM += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBN += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBO += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBP += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBQ += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBR += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBS += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBT += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBU += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBV += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBW += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBX += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBY += GetRoundedRandom();
                currentlyUpdatedOrder.ColumnBZ += GetRoundedRandom();

                currentlyUpdatedOrder.Type = Order.RandomType();
            }
            //only fire the event if activated
            if (TickerBuffer.IsCollectionChangedActivated)
                RaiseCollectionChanged();
        }



        public void StartFeed()
        {
            updateTimer.Start();
        }
        public void StopFeed()
        {
            updateTimer.Stop();
        }

        public void FillWindow()
        {
            _dataSource.Clear();
            for (int i = 0; i < _windowSize; ++i)
            {
                _dataSource.Add(Order.Initialize());
            }
        }

        #region IEnumerable Members

        public IEnumerator GetEnumerator()
        {
            return _dataSource.GetEnumerator();
        }

        #endregion

        #region INotifyCollectionChanged Members

        public event NotifyCollectionChangedEventHandler CollectionChanged;
        public void RaiseCollectionChanged()
        {
            if (CollectionChanged != null)
                CollectionChanged(this, new NotifyCollectionChangedEventArgs(NotifyCollectionChangedAction.Reset));
        }

        #endregion


        int IList.Add(object value)
        {
            if (value is Order)
            {
                _dataSource.Add(value as Order);
                return _dataSource.IndexOf(value as Order);
            }

            return -1;
        }

        void IList.Clear()
        {
            _dataSource.Clear();
        }

        bool IList.Contains(object value)
        {
            if (value is Order)
                return _dataSource.Contains(value as Order);

            return false;
        }

        int IList.IndexOf(object value)
        {
            if (value is Order)
                return _dataSource.IndexOf(value as Order);

            return -1;
        }

        void IList.Insert(int index, object value)
        {
            throw new NotImplementedException();
        }

        bool IList.IsFixedSize
        {
            get { return false; }
        }

        bool IList.IsReadOnly
        {
            get { return true; }
        }

        void IList.Remove(object value)
        {
            if (value is Order)
                _dataSource.Remove(value as Order);
        }

        void IList.RemoveAt(int index)
        {
            if (index < _dataSource.Count)
                _dataSource.RemoveAt(index);
        }

        public object this[int index]
        {
            get
            {
                return _dataSource[index];
            }
            set
            {
                if (value is Order)
                    _dataSource[index] = value as Order;
            }
        }

        public void CopyTo(Array array, int index)
        {
            foreach (Order o in _dataSource)
            {
                array.SetValue(o, index++);
            }
        }

        public int Count
        {
            get { return _dataSource.Count; }
        }

        public bool IsSynchronized
        {
            get { return false; }
        }

        public object SyncRoot
        {
            get { return new object(); }
        }
    }

    public class Order : INotifyPropertyChanged
    {
        #region properties

        public int ID
        {
            get
            {
                return _id;
            }
            set
            {
                _id = value;
                RaisePropertyChanged("ID");
            }
        }

        public string Symbol
        {
            get
            {
                return _symbol;
            }
            set
            {
                _symbol = value;
                RaisePropertyChanged("Symbol");
            }
        }
        string _side;
        public string Side
        {
            get
            {
                return _side;
            }
            set
            {
                _side = value;
                RaisePropertyChanged("Side");
            }
        }
        int _size;
        public int Size
        {
            get
            {
                return _size;
            }
            set
            {
                _size = value;
                RaisePropertyChanged("Size");
            }
        }
        public int Filled
        {
            get
            {
                return _filled;
            }
            set
            {
                _filled = value;
                RaisePropertyChanged("Filled");
            }
        }
        public int Remain
        {
            get
            {
                return _remain;
            }
            set
            {
                _remain = value;
                RaisePropertyChanged("Remain");
            }
        }

        public string Type
        {
            get
            {
                return _type;
            }
            set
            {
                _type = value;
                RaisePropertyChanged("Type");
            }
        }
        public string Status
        {
            get
            {
                return _status;
            }
            set
            {
                _status = value;
                RaisePropertyChanged("Status");
            }
        }

        private decimal _columnA;
        public decimal ColumnA
        {
            get
            {
                return _columnA;
            }
            set
            {
                _columnA = value;
                RaisePropertyChanged("ColumnA");
            }
        }
        private decimal _columnB;
        public decimal ColumnB
        {
            get
            {
                return _columnB;
            }
            set
            {
                _columnB = value;
                RaisePropertyChanged("ColumnB");
            }
        }
        private decimal _columnC;
        public decimal ColumnC
        {
            get
            {
                return _columnC;
            }
            set
            {
                _columnC = value;
                RaisePropertyChanged("ColumnC");
            }
        }
        private decimal _columnD;
        public decimal ColumnD
        {
            get
            {
                return _columnD;
            }
            set
            {
                _columnD = value;
                RaisePropertyChanged("ColumnD");
            }
        }
        private decimal _columnE;
        public decimal ColumnE
        {
            get
            {
                return _columnE;
            }
            set
            {
                _columnE = value;
                RaisePropertyChanged("ColumnE");
            }
        }
        private decimal _columnF;
        public decimal ColumnF
        {
            get
            {
                return _columnF;
            }
            set
            {
                _columnF = value;
                RaisePropertyChanged("ColumnF");
            }
        }
        private decimal _columnG;
        public decimal ColumnG
        {
            get
            {
                return _columnG;
            }
            set
            {
                _columnG = value;
                RaisePropertyChanged("ColumnG");
            }
        }
        private decimal _columnH;
        public decimal ColumnH
        {
            get
            {
                return _columnH;
            }
            set
            {
                _columnH = value;
                RaisePropertyChanged("ColumnH");
            }
        }
        private decimal _columnI;
        public decimal ColumnI
        {
            get
            {
                return _columnI;
            }
            set
            {
                _columnI = value;
                RaisePropertyChanged("ColumnI");
            }
        }
        private decimal _columnJ;
        public decimal ColumnJ
        {
            get
            {
                return _columnJ;
            }
            set
            {
                _columnJ = value;
                RaisePropertyChanged("ColumnJ");
            }
        }
        private decimal _columnK;
        public decimal ColumnK
        {
            get
            {
                return _columnK;
            }
            set
            {
                _columnK = value;
                RaisePropertyChanged("ColumnK");
            }
        }
        private decimal _columnL;
        public decimal ColumnL
        {
            get
            {
                return _columnL;
            }
            set
            {
                _columnL = value;
                RaisePropertyChanged("ColumnL");
            }
        }
        private decimal _columnM;
        public decimal ColumnM
        {
            get
            {
                return _columnM;
            }
            set
            {
                _columnM = value;
                RaisePropertyChanged("ColumnM");
            }
        }
        private decimal _columnN;
        public decimal ColumnN
        {
            get
            {
                return _columnN;
            }
            set
            {
                _columnN = value;
                RaisePropertyChanged("ColumnN");
            }
        }
        private decimal _columnO;
        public decimal ColumnO
        {
            get
            {
                return _columnO;
            }
            set
            {
                _columnO = value;
                RaisePropertyChanged("ColumnO");
            }
        }
        private decimal _columnP;
        public decimal ColumnP
        {
            get
            {
                return _columnP;
            }
            set
            {
                _columnP = value;
                RaisePropertyChanged("ColumnP");
            }
        }
        private decimal _columnQ;
        public decimal ColumnQ
        {
            get
            {
                return _columnQ;
            }
            set
            {
                _columnQ = value;
                RaisePropertyChanged("ColumnQ");
            }
        }
        private decimal _columnR;
        public decimal ColumnR
        {
            get
            {
                return _columnR;
            }
            set
            {
                _columnR = value;
                RaisePropertyChanged("ColumnR");
            }
        }
        private decimal _columnS;
        public decimal ColumnS
        {
            get
            {
                return _columnS;
            }
            set
            {
                _columnS = value;
                RaisePropertyChanged("ColumnS");
            }
        }
        private decimal _columnT;
        public decimal ColumnT
        {
            get
            {
                return _columnT;
            }
            set
            {
                _columnT = value;
                RaisePropertyChanged("ColumnT");
            }
        }
        private decimal _columnU;
        public decimal ColumnU
        {
            get
            {
                return _columnU;
            }
            set
            {
                _columnU = value;
                RaisePropertyChanged("ColumnU");
            }
        }
        private decimal _columnV;
        public decimal ColumnV
        {
            get
            {
                return _columnV;
            }
            set
            {
                _columnV = value;
                RaisePropertyChanged("ColumnV");
            }
        }
        private decimal _columnW;
        public decimal ColumnW
        {
            get
            {
                return _columnW;
            }
            set
            {
                _columnW = value;
                RaisePropertyChanged("ColumnW");
            }
        }
        private decimal _columnX;
        public decimal ColumnX
        {
            get
            {
                return _columnX;
            }
            set
            {
                _columnX = value;
                RaisePropertyChanged("ColumnX");
            }
        }
        private decimal _columnY;
        public decimal ColumnY
        {
            get
            {
                return _columnY;
            }
            set
            {
                _columnY = value;
                RaisePropertyChanged("ColumnY");
            }
        }
        private decimal _columnZ;
        public decimal ColumnZ
        {
            get
            {
                return _columnZ;
            }
            set
            {
                _columnZ = value;
                RaisePropertyChanged("ColumnZ");
            }
        }

        public decimal ColumnAA { get; set; }
        public decimal ColumnAB { get; set; }
        public decimal ColumnAC { get; set; }
        public decimal ColumnAD { get; set; }
        public decimal ColumnAE { get; set; }
        public decimal ColumnAF { get; set; }
        public decimal ColumnAG { get; set; }
        public decimal ColumnAH { get; set; }
        public decimal ColumnAI { get; set; }
        public decimal ColumnAJ { get; set; }
        public decimal ColumnAK { get; set; }
        public decimal ColumnAL { get; set; }
        public decimal ColumnAM { get; set; }
        public decimal ColumnAN { get; set; }
        public decimal ColumnAO { get; set; }
        public decimal ColumnAP { get; set; }
        public decimal ColumnAQ { get; set; }
        public decimal ColumnAR { get; set; }
        public decimal ColumnAS { get; set; }
        public decimal ColumnAT { get; set; }
        public decimal ColumnAU { get; set; }
        public decimal ColumnAV { get; set; }
        public decimal ColumnAW { get; set; }
        public decimal ColumnAX { get; set; }
        public decimal ColumnAY { get; set; }
        public decimal ColumnAZ { get; set; }
        public decimal ColumnBA { get; set; }
        public decimal ColumnBB { get; set; }
        public decimal ColumnBC { get; set; }
        public decimal ColumnBD { get; set; }
        public decimal ColumnBE { get; set; }
        public decimal ColumnBF { get; set; }
        public decimal ColumnBG { get; set; }
        public decimal ColumnBH { get; set; }
        public decimal ColumnBI { get; set; }
        public decimal ColumnBJ { get; set; }
        public decimal ColumnBK { get; set; }
        public decimal ColumnBL { get; set; }
        public decimal ColumnBM { get; set; }
        public decimal ColumnBN { get; set; }
        public decimal ColumnBO { get; set; }
        public decimal ColumnBP { get; set; }
        public decimal ColumnBQ { get; set; }
        public decimal ColumnBR { get; set; }
        public decimal ColumnBS { get; set; }
        public decimal ColumnBT { get; set; }
        public decimal ColumnBU { get; set; }
        public decimal ColumnBV { get; set; }
        public decimal ColumnBW { get; set; }
        public decimal ColumnBX { get; set; }
        public decimal ColumnBY { get; set; }
        public decimal ColumnBZ { get; set; }
        #endregion

        static int _LastID = 1;
        static string _Letters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        static Random _rnd = new Random();
        static string[] _Sides = { "B", "S", "BC", "SS" };
        static string[] _Types = { "MKT", "L AGGR", "L BID", "L ASK", "L MID" };

        public Order()
        {

        }

        public static Order Initialize()
        {
            Order myO = new Order();
            myO.ID = (int)_LastID++;
            myO.Symbol = (string)String.Format("{0}{1}{2}{3}",
                                                _Letters[_rnd.Next(0, _Letters.Length)],
                                                _Letters[_rnd.Next(0, _Letters.Length)],
                                                _Letters[_rnd.Next(0, _Letters.Length)],
                                                _Letters[_rnd.Next(0, _Letters.Length)]);
            myO.Side = (string)_Sides[_rnd.Next(0, _Sides.Length)];
            int i = _rnd.Next(100);
            myO.Size = i;
            myO.Filled = (int)(0);
            myO.Remain = (int)(1000);
            myO.Status = "Partial";
            myO.Type = (string)_Types[_rnd.Next(0, _Types.Length)];
            myO.ColumnA = (decimal)(i + 4);
            myO.ColumnB = (decimal)(i + 5);
            myO.ColumnC = (decimal)(i + 6);
            myO.ColumnD = (decimal)(i + 7);
            myO.ColumnE = (decimal)(i + 8);
            myO.ColumnF = (decimal)(i + 9);
            myO.ColumnG = (decimal)(i + 10);
            myO.ColumnH = (decimal)(i + 11);
            myO.ColumnI = (decimal)(i + 12);
            myO.ColumnJ = (decimal)(i + 13);
            myO.ColumnK = (decimal)(i + 14);
            myO.ColumnL = (decimal)(i + 15);
            myO.ColumnM = (decimal)(i + 16);
            myO.ColumnN = (decimal)(i + 17);
            myO.ColumnO = (decimal)(i + 18);
            myO.ColumnP = (decimal)(i + 19);
            myO.ColumnQ = (decimal)(i + 20);
            myO.ColumnR = (decimal)(i + 21);
            myO.ColumnS = (decimal)(i + 22);
            myO.ColumnT = (decimal)(i + 23);
            myO.ColumnU = (decimal)(i + 16);
            myO.ColumnV = (decimal)(i + 17);
            myO.ColumnW = (decimal)(i + 18);
            myO.ColumnX = (decimal)(i + 19);
            myO.ColumnY = (decimal)(i + 20);
            myO.ColumnZ = (decimal)(i + 21);
            myO.ColumnAA = (decimal)(i + 4);
            myO.ColumnAB = (decimal)(i + 5);
            myO.ColumnAC = (decimal)(i + 6);
            myO.ColumnAD = (decimal)(i + 7);
            myO.ColumnAE = (decimal)(i + 8);
            myO.ColumnAF = (decimal)(i + 9);
            myO.ColumnAG = (decimal)(i + 10);
            myO.ColumnAH = (decimal)(i + 11);
            myO.ColumnAI = (decimal)(i + 12);
            myO.ColumnAJ = (decimal)(i + 13);
            myO.ColumnAK = (decimal)(i + 14);
            myO.ColumnAL = (decimal)(i + 15);
            myO.ColumnAM = (decimal)(i + 16);
            myO.ColumnAN = (decimal)(i + 17);
            myO.ColumnAO = (decimal)(i + 18);
            myO.ColumnAP = (decimal)(i + 19);
            myO.ColumnAQ = (decimal)(i + 20);
            myO.ColumnAR = (decimal)(i + 21);
            myO.ColumnAS = (decimal)(i + 22);
            myO.ColumnAT = (decimal)(i + 23);
            myO.ColumnAU = (decimal)(i + 16);
            myO.ColumnAV = (decimal)(i + 17);
            myO.ColumnAW = (decimal)(i + 18);
            myO.ColumnAX = (decimal)(i + 19);
            myO.ColumnAY = (decimal)(i + 20);
            myO.ColumnAZ = (decimal)(i + 21);
            myO.ColumnBA = (decimal)(i + 4);
            myO.ColumnBB = (decimal)(i + 5);
            myO.ColumnBC = (decimal)(i + 6);
            myO.ColumnBD = (decimal)(i + 7);
            myO.ColumnBE = (decimal)(i + 8);
            myO.ColumnBF = (decimal)(i + 9);
            myO.ColumnBG = (decimal)(i + 10);
            myO.ColumnBH = (decimal)(i + 11);
            myO.ColumnBI = (decimal)(i + 12);
            myO.ColumnBJ = (decimal)(i + 13);
            myO.ColumnBK = (decimal)(i + 14);
            myO.ColumnBL = (decimal)(i + 15);
            myO.ColumnBM = (decimal)(i + 16);
            myO.ColumnBN = (decimal)(i + 17);
            myO.ColumnBO = (decimal)(i + 18);
            myO.ColumnBP = (decimal)(i + 19);
            myO.ColumnBQ = (decimal)(i + 20);
            myO.ColumnBR = (decimal)(i + 21);
            myO.ColumnBS = (decimal)(i + 22);
            myO.ColumnBT = (decimal)(i + 23);
            myO.ColumnBU = (decimal)(i + 16);
            myO.ColumnBV = (decimal)(i + 17);
            myO.ColumnBW = (decimal)(i + 18);
            myO.ColumnBX = (decimal)(i + 19);
            myO.ColumnBY = (decimal)(i + 20);
            myO.ColumnBZ = (decimal)(i + 21);

            return myO;
        }

        public static string RandomType()
        {
            return _Types[_rnd.Next(0, _Types.Length)];
        }

        public event PropertyChangedEventHandler PropertyChanged;
        public static bool IsPropertyChangedActivated;

        public void RaisePropertyChanged(string name)
        {
            //only fire the event if changed notifications are activated
            if (!String.IsNullOrEmpty(name) && !IsPropertyChangedActivated)// && !name.Equals("Type"))
                return;

            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }

        public string _status;
        private string _type;
        private int _remain;
        private int _filled;
        private int _id;
        private string _symbol;

    }
}
